Scene_Buy = {};

Scene_Buy.noinet = false;
Scene_Buy.prevScene = null;

Scene_Buy.onSet = function(params)
{
	
	if (params) {
		Scene_Buy.prevScene = params.prevScene;
	}
	
	Scene_Buy.noinet = false;
	
	var handlers = {
		inetErrorHandler : Scene_Buy.onInetError,
		buyHandler : Scene_Buy.onBuy,
		nextHandler : Scene_Buy.onNext,
		prevHandler : Scene_Buy.onPrev
	};
	
	Model_Video.setHandlers(handlers);
	
	AppManager.setLayout('Buy');
	
	if (Model_Main.curPType == Model_Main.PTYPE_BOY) 
		$('#buy_boy').css('display', 'block');
	else 
		$('#buy_girl').css('display', 'block');
	
	View_Video.showPreloader();
	
	
	Model_Video.loadBuyList(function(){
		
		//в случае успешной загрузки списка, инициалищируем слайдер превьюшек
		
		//параметры для слайдера
		var params = {
			images : Model_Video.getPreviewList(),
			imgW : 401,
			imgH : 231,
			scrW : 960,
			margin : 15,
			handlers : {
				'onInited' : View_Video.hidePreloader,
				'onSwappingStart' : View_Video.showPreloader,
				'onSwappingEnd' : View_Video.hidePreloader,
				'onLoadingError' : Scene_Buy.onInetError
			}
		}
		
		View_Video.showButtonsBuy();
		$('#slider').idcSlider('init', params);
	});
	
	
}

Scene_Buy.onUnSet = function()
{
	Model_Video.clear();
	Scene_Buy.prevScene = null;
}


Scene_Buy.onKeyDown = function()
{
	if (event.keyCode == tvKey.KEY_RETURN)
		widgetAPI.blockNavigation(event);
	
	if (View_Video.previewAnimated()) {
	
		alert('anim');
		return;	
	}
	if (View_Video.preloader && (event.keyCode != tvKey.KEY_EXIT)){
		
			alert('preloader');
			return;
	}
		
	
	switch (event.keyCode) {
		
		case tvKey.KEY_LEFT:
			if (View_Message.shown) return;
			Model_Video.prev();
			break;
			
		case tvKey.KEY_RIGHT:
			if (View_Message.shown) return;
			Model_Video.next();
			break;
			
		case tvKey.KEY_ENTER:
			if (View_Message.shown) {
				if (Scene_Buy.noinet) {
					widgetAPI.sendExitEvent();
				}
				return;
			}
			
			
			
			View_Video.showPreloader();
			Model_Video.buy();
	
			break;
		
			
		case tvKey.KEY_RETURN:
				
			if (View_Message.shown) {			
				View_Message.hideMessage();
				if ( Scene_Buy.noinet) {
					
					AppManager.setScene(Scene_Main);
				}
				else {
					View_Video.showButtonsBuy();
				}
			}
			else {
				if (Scene_Buy.prevScene == 'video')
					AppManager.setScene(Scene_Video);
				else
					AppManager.setScene(Scene_Main);
			}
		
			break;
			
		case tvKey.KEY_EXIT:
			
			widgetAPI.blockNavigation(event);
			widgetAPI.sendExitEvent();
			break;
	}
}

Scene_Buy.onInetError = function()
{
	View_Video.hidePreloader();
	View_Message.showMessage(View_Message.INET_ERROR, View_Video.buttonsError)
	Scene_Buy.noinet = true;
}

Scene_Buy.onBuy = function(mes)
{
	View_Video.hidePreloader();
	View_Message.showMessage(mes, View_Video.buttonsBuyMes)
}

Scene_Buy.onNext = function()
{
	$('#slider').idcSlider('next');
}

Scene_Buy.onPrev = function()
{
	$('#slider').idcSlider('prev');
}