Model_Patefon = {}

Model_Patefon.matrix = null;
Model_Patefon.queue  = null;

Model_Patefon.NN = 9;
Model_Patefon.QN = 5;
Model_Patefon.COLORS = 9;
Model_Patefon.points = null;

Model_Patefon.g.H = null;
Model_Patefon.g.W = null;
Model_Patefon.g.L = null;
Model_Patefon.g.R = null;

Model_Patefon.g.Wd2 = null;


Model_Patefon.setHandlers = function(handlers)
{
	Model_Patefon.handlerQMove = handlers.handlerQMove;
	Model_Patefon.handlerPMove = handlers.handlerPMove;
	Model_Patefon.handlerDelBlock = handlers.handlerDelBlock;
}




Model_Patefon.startGame = function()
{
	var i, j;

	Model_Patefon.point = 0;
	Model_Patefon.matrixInit();
	Model_Patefon.queueInit();
	
	for (i = 0; i < 3; i++) {
		for (j = 0; j < Model_Patefon.NN; j++) {
			Model_Patefon.matrix[i][j] = Model_Patefon.getRandomColor();
		}
	}
}

Model_Patefon.course = function(offset)
{
	
}

Model_Patefon.handleCourse = function(ii, jj)
{
	var block = Model_Patefon.getBlock(ii, jj, null);
	if (block.length >= 3) {
		
		Model_Patefon.delBlock(block);
	}
	else {
		
		
	}
	
	Model_Patefon.handlerQMove.call(null, block);
	
}



Model_Patefon.matrixInit = function()
{
	var i, j;
	Model_Patefon.matrix = new Array( Model_Patefon.NN );
	for (i=0; i<Model_Patefon.NN; i++) {
		
		Model_Patefon.matrix[i] = new Array( Model_Patefon.NN );
		for (j=0; j<Model_Patefon.NN; j++) {
			Model_Patefon.matrix[i][j] = 0;
		}
	}
}

Model_Patefon.queueInit = function()
{
	Model_Patefon.queue = new Array(5);
	for(var i=0; i<Model_Patefon.QN; i++)
		Model_Patefon.queue[i] = Model_Patefon.getRandomColor();
}

Model_Patefon.queuePop = function()
{
	var result = Model_Patefon.queue[0];
	for (var i=1; i<Model_Patefon.QN; i++)
		Model_Patefon.queue[i-1] = Model_Patefon.queue[i];
	
	Model_Patefon.queue[ Model_Patefon.QN-1 ] = Model_Patefon.getRandomColor();
	
	return result;
}

Model_Patefon.delBlock = function(block)
{
	for (var i = 0; i < block.length; i++) {
		
		Model_Patefon.setColor(block[i][0], block[i][1], 0);
		Model_Patefon.point += 30;
	}
	
	Model_Patefon.handlerDelBlock.call(null, block);
}


Model_Patefon.getRandomColor = function()
{
	var c = Math.floor( Math.random( ) * (Model_Lines.COLORS) ) + 1;
	return c;
}

Model_Patefon.getNeighbors = function(i, j)
{
	var result = [];
	
	if ( Model_Patefon.pointExists(i, j-1) )
		result.push([i, j-1]);
	
	if ( Model_Patefon.pointExists(i, j+1) )
		result.push([i, j+1]);
	
	if ( Model_Patefon.pointExists(i-1, j) )
		result.push([i-1, j]);
	
	if ( Model_Patefon.pointExists(i+1, j) )
		result.push([i+1, j]);
	
	if (i % 2 == 0) {
		
		if ( Model_Patefon.pointExists(i-1, j-1) )
			result.push([i-1, j-1]);
	
		if ( Model_Patefon.pointExists(i+1, j-1) )
			result.push([i+1, j-1]);
	}
	
	else {
		
		if ( Model_Patefon.pointExists(i-1, j+1) )
			result.push([i-1, j+1]);
	
		if ( Model_Patefon.pointExists(i+1, j+1) )
			result.push([i+1, j+1]);
	}
	
	return result;
}

Model_Patefon.pointExists = function(i, j)
{
	return ( (i>0) && (i<Model_Lines.NN) && (j>0) && (j<Model_Lines.NN) );
}

Model_Patefon.getColor = function (i, j)
{
	return Model_Patefon.matrix[i][j];
}

Model_Patefon.setColor = function(i, j, c)
{
	Model_Patefon.matrix[i][j] = c;
}

Model_Patefon.getBlock = function(ii, jj, block)
{
	var c = Model_Patefon.getColor(ii, jj);
	var neighbors = Model_Patefon.getNeighbors(ii, jj);
	var p;
	
	if (! block)
		block = [ [ii, jj] ];
	
	for (var i=0; i<neighbors.length; i++ ) {
		
		if ( c == Model_Patefon.getColor(neighbors[i][0], neighbors[i][1]) ) {
			
			p = [ neighbors[i][0], neighbors[i][1] ];
			if (! Model_Patefon.pInBlock(block, p)) {
				
				block = Model_Patefon.getBlock(p[0], p[1], block);
			}
		}
	}
	
	return block;
}

Model_Patefon.pInBlock = function(block, p)
{
	for (var i=0; i<block.length; i++)
		if ( (block[i][0] == p[0]) && (block[i][1] == p[1]) ) {
			return true;
		}
	
	return false;
}



Model_Patefon.g.init = function(params)
{
	Model_Patefon.g.H = params.H;
	Model_Patefon.g.W = params.W;
	Model_Patefon.g.L = params.L;
	Model_Patefon.g.R = params.L;
	
	Model_Patefon.g.Wd2 = params.W / 2;
}

Model_Patefon.g.getTrack = function(xx)
{
	
}